function varargout = artistic(varargin)
% ARTISTIC M-file for artistic.fig
%      ARTISTIC, by itself, creates a new ARTISTIC or raises the existing
%      singleton*.
%
%      H = ARTISTIC returns the handle to a new ARTISTIC or the handle to
%      the existing singleton*.
%
%      ARTISTIC('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ARTISTIC.M with the given input arguments.
%
%      ARTISTIC('Property','Value',...) creates a new ARTISTIC or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before artistic_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to artistic_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help artistic

% Last Modified by GUIDE v2.5 13-Aug-2007 12:35:02

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @artistic_OpeningFcn, ...
                   'gui_OutputFcn',  @artistic_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before artistic is made visible.
function artistic_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to artistic (see VARARGIN)

% Choose default command line output for artistic
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes artistic wait for user response (see UIRESUME)
% uiwait(handles.figure1);

handles.sigma = 3;
handles.number = 8;
handles.q = 8;
guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function varargout = artistic_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in load_image.
function load_image_Callback(hObject, eventdata, handles)
% hObject    handle to load_image (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[FileName,PathName] = uigetfile({'*.jpg; *.jpeg; *.png; *.bmp; *.hdf; *.pbm; *.pcx; *.pgm; *.pnm; *.ppm; *.ras; *.tif; *.tiff; *.xwd', 'All Image Files'; ...
 '*.jpg; *.jpeg','JPEG (*.jpg, *.jpeg)'; ...
 '*.png','Portable Network Graphics (*.png)'; ...
 '*.bmp','Windows Bitmap (*.bmp)'; ...
 '*.hdf','Hierarchical Data Format (*.hdf)'; ...
 '*.pbm','Portable Bitmap (*.pbm)'; ...
 '*.pcx','Windows Paintbrush (*.pcx)'; ...
 '*.pgm','Portable Graymap (*.pgm)'; ...
 '*.pnm','Portable Anymap (*.pnm)'; ...
 '*.ppm','Portable Pixmap (*.ppm)'; ...
 '*.ras','Sun Raster (*.ras)'; ...
 '*.tif; *.tiff','Tagged Image File Format (*.tif, *.tiff)'; ...
 '*.xwd','X Windows Dump (*.xwd)'; ...
 '*', 'All Files (*.*)'}, ...
 'Load image');

if FileName
    handles.img = double(imread([PathName,FileName]))/255;
    guidata(hObject, handles);
    
    axes(handles.image);
    imshow(handles.img);
    
    
    [nr,nc,N] = size(handles.img);
    
    s = 700/max(nr,nc); if s > 1, s = 1;, end
    
    h_graf = gca;
    set(h_graf, 'Position', [161, 707-nr*s, nc*s, nr*s]);
    set(h_graf, 'Visible', 'On', 'XTick', [], 'YTick', []);
    
    
    h_but = findobj('Tag', 'create');
    set(h_but, 'Enable', 'On');
    
    h_show  = findobj('Tag', 'show_img');
    set(h_show, 'Enable', 'off');
end


% --- Executes on button press in create.
function create_Callback(hObject, eventdata, handles)
% hObject    handle to create (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(hObject, 'Enable', 'off');

h_wait = findobj('Tag', 'wait')
set(h_wait, 'String', 'Please wait...');

sigma = handles.sigma;
number = handles.number;
q = handles.q;

handles.out = painter(handles.img, sigma, number, q/2);
guidata(hObject, handles);

axes(handles.image);
imshow(handles.out);

set(h_wait, 'String', '');


h_show  = findobj('Tag', 'show_img');
set(h_show, 'Enable', 'on');

h_save  = findobj('Tag', 'save_effect');
set(h_save, 'Enable', 'on');

% --- Executes during object creation, after setting all properties.
function sigma_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sigma (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function sigma_Callback(hObject, eventdata, handles)
% hObject    handle to sigma (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sigma as text
%        str2double(get(hObject,'String')) returns contents of sigma as a double

handles.sigma = str2double(get(hObject,'String'));
guidata(hObject, handles);

h_but = findobj('Tag', 'create');
set(h_but, 'Enable', 'On');

% --- Executes during object creation, after setting all properties.
function number_CreateFcn(hObject, eventdata, handles)
% hObject    handle to number (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function number_Callback(hObject, eventdata, handles)
% hObject    handle to number (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of number as text
%        str2double(get(hObject,'String')) returns contents of number as a double

handles.number = str2double(get(hObject,'String'));
guidata(hObject, handles);

h_but = findobj('Tag', 'create');
set(h_but, 'Enable', 'On');


% --- Executes during object creation, after setting all properties.
function q_CreateFcn(hObject, eventdata, handles)
% hObject    handle to q (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function q_Callback(hObject, eventdata, handles)
% hObject    handle to q (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of q as text
%        str2double(get(hObject,'String')) returns contents of q as a double

handles.q = str2double(get(hObject,'String'));
guidata(hObject, handles);

h_but = findobj('Tag', 'create');
set(h_but, 'Enable', 'On');

% --- Executes on button press in togglebutton2.
function togglebutton2_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of togglebutton2


% --- Executes on button press in togglebutton3.
function togglebutton3_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of togglebutton3


% --- Executes on button press in artistic_effect.
function artistic_effect_Callback(hObject, eventdata, handles)
% hObject    handle to artistic_effect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of artistic_effect


% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on button press in show_img.
function show_img_Callback(hObject, eventdata, handles)
% hObject    handle to show_img (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

axes(handles.image);

if strcmp(get(hObject, 'String'), 'Show input image')
    imshow(handles.img);
    set(hObject, 'String', 'Show artistic effect');
else
    imshow(handles.out);
    set(hObject, 'String', 'Show input image');
end


% --- Executes on button press in save_effect.
function save_effect_Callback(hObject, eventdata, handles)
% hObject    handle to save_effect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[FileName,PathName] = uiputfile( ...
{'*.png','Portable Network Graphics (*.png)'; ...
 '*.bmp','Windows Bitmap (*.bmp)'; ...
 '*.hdf','Hierarchical Data Format (*.hdf)'; ...
 '*.jpg','JPEG (*.jpg)'; ...
 '*.pbm','Portable Bitmap (*.pbm)'; ...
 '*.pcx','Windows Paintbrush (*.pcx)'; ...
 '*.pgm','Portable Graymap (*.pgm)'; ...
 '*.ppm','Portable Pixmap (*.ppm)'; ...
 '*.ras','Sun Raster (*.ras)'; ...
 '*.tif','Tagged Image File Format (*.tif)'; ...
 '*.xwd','X Windows Dump (*.xwd)'}, ...
 'Save artistic effect');

if FileName
    imwrite(handles.out, [PathName,FileName]);
end
